## cargo 0.35.0

=== debian/changelog ===
cargo (0.35.0-2~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 06 Sep 2019 09:57:36 -0700

cargo (0.35.0-2) unstable; urgency=medium

  * Use more portable flags in tests, fixing FTBFS on mips.
    (Closes: #930218)

 -- Ximin Luo <infinity0@debian.org>  Sat, 08 Jun 2019 11:04:43 -0700

cargo (0.35.0-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 31 May 2019 00:29:11 -0700

=== debian/control ===
Source: cargo
Section: devel
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders: Luca Bruno <lucab@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>,
 Vasudev Kamath <vasudev@copyninja.info>
Priority: optional
# :native annotations are to support cross-compiling, see README.Debian of rustc
Build-Depends: debhelper (>= 9.20141010),
               dpkg-dev (>= 1.17.14),
               cargo:native    (>= 0.17.0),
               rustc:native    (>= 1.16),
               libstd-rust-dev (>= 1.16),
               pkg-config,
               cmake,
               bash-completion,
               python3:native,
               libcurl4-gnutls-dev | libcurl4-openssl-dev,
               libssh2-1-dev,
               libgit2-dev (>= 0.27),
               libhttp-parser-dev,
               libssl-dev,
               zlib1g-dev,
               git <!nocheck>
Homepage: https://crates.io/
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/rust-team/cargo.git
Vcs-Browser: https://salsa.debian.org/rust-team/cargo

Package: cargo
Architecture: any
Multi-Arch: allowed
Depends: ${shlibs:Depends}, ${misc:Depends},
         rustc (>= 1.24),
         binutils,
         gcc | clang | c-compiler
Suggests: cargo-doc, python3
Description: Rust package manager
 Cargo is a tool that allows Rust projects to declare their various
 dependencies, and ensure that you'll always get a repeatable build.
 .
 To accomplish this goal, Cargo does four things:
  * Introduces two metadata files with various bits of project information.
  * Fetches and builds your project's dependencies.
  * Invokes rustc or another build tool with the correct parameters to build
    your project.
  * Introduces conventions, making working with Rust projects easier.
 .
 Cargo downloads your Rust project’s dependencies and compiles your
 project.

Package: cargo-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: Rust package manager, documentation
 Cargo is a tool that allows Rust projects to declare their various
 dependencies, and ensure that you'll always get a repeatable build.
 .
 To accomplish this goal, Cargo does four things:
  * Introduces two metadata files with various bits of project information.
  * Fetches and builds your project's dependencies.
  * Invokes rustc or another build tool with the correct parameters to build
    your project.
  * Introduces conventions, making working with Rust projects easier.
 .
 Cargo downloads your Rust project’s dependencies and compiles your
 project.
 .
 This package contains the documentation.

# TODO: add a cargo-src package

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

CARGO = $(CURDIR)/debian/bin/cargo

export CARGO_HOME = $(CURDIR)/debian/cargo_home
export DEB_CARGO_CRATE=cargo_$(DEB_VERSION_UPSTREAM)
export DEB_CARGO_PACKAGE=cargo
export RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/cargo-$(DEB_VERSION_UPSTREAM)

# don't shrink, this can take ages
# see https://github.com/rust-lang/cargo/issues/6490 for details
export PROPTEST_MAX_SHRINK_ITERS = 0
export CARGO_TEST_SLOW_CPU_MULTIPLIER = 4

# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     CARGO_TEST_FLAGS="package::include -- <args ...>"
# See `cargo test --help` for more options.
CARGO_TEST_FLAGS =

%:
	dh $@ --with bash-completion

override_dh_auto_configure:
	$(CARGO) prepare-debian $(CURDIR)/vendor

override_dh_auto_build-arch:
	$(CARGO) build

override_dh_auto_build-indep:
	$(CARGO) doc

override_dh_auto_test-arch:
	CFG_DISABLE_CROSS_TESTS=1 $(CARGO) test $(CARGO_TEST_FLAGS)

override_dh_auto_test-indep:
	# no arch-indep tests

override_dh_auto_install:
	$(CARGO) install

override_dh_auto_clean:
	$(CARGO) clean

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## cargo 0.36.0

=== debian/changelog ===
cargo (0.36.0-0ubuntu1~19.04.1) disco; urgency=medium

  * Backport to disco.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 11 Jul 2019 12:05:05 +0200

cargo (0.36.0-0ubuntu1) eoan; urgency=medium

  * New upstream version.
    - Refreshed patches.
    - Remove d/patches/typenum-rounding.patch, applied upstream.
    - Add d/patches/disable-large_conflict_cache-test-on-non-x86.patch

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 08 Jul 2019 14:11:59 +0200

cargo (0.35.0-0ubuntu1) eoan; urgency=medium

  * New upstream version.
    - Refresh patches.
    - Remove d/patches/1003_increase_timeout_for_slow_arches_like_mips.patch,
      no longer needed.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 17 May 2019 11:25:23 +1200

## cargo 0.37.0

=== debian/changelog ===
cargo (0.37.0-3ubuntu2) eoan; urgency=medium

  * Backport fix causing build failures when $HOME was not writable.
    - add debian/patches/0001-Don-t-fail-if-we-can-t-acquire-readonly-lock.patch
    - update debian/patches/series

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 27 Aug 2019 20:33:21 +1200

cargo (0.37.0-3ubuntu1) eoan; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh
    - Disable fetch tests on non x86/x86-64 architectures, as those hit an
      unreachable!() in test code. Disable the Debian patch that disables these
      tests on every architecture
      - add debian/patches/disable-fetch-tests-on-non-x86.patch
      - update debian/patches/series
    - Disable test tool_paths::custom_runner which fails every now and again
      because of a libstd bug (https://github.com/rust-lang/rust/issues/55242)
      - add debian/patches/disable-tool_paths-custom_runner.patch
      - update debian/patches/series
   - Disable the large_conflict_cache test on non-x86
     - add debian/patches/disable-large_conflict_cache-test-on-non-x86.patch
     - update debian/patches/series

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Sat, 17 Aug 2019 13:57:21 +1200

cargo (0.37.0-3) unstable; urgency=medium

  * Update 2001_more_portable_rustflags.patch, fixes mips FTBFS

 -- Ximin Luo <infinity0@debian.org>  Sat, 20 Jul 2019 16:02:08 -0700

cargo (0.37.0-2) unstable; urgency=medium

  * Bump serde vendored crate version up to 1.0.96 to avoid issue when
    compiling with atomics (the default).

 -- Ximin Luo <infinity0@debian.org>  Thu, 18 Jul 2019 02:34:48 -0700

cargo (0.37.0-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 16 Jul 2019 23:06:49 -0700

=== debian/rules ===
--- 
+++ 
@@ -53,6 +53,3 @@
 override_dh_clean:
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## cargo 0.38.0

=== debian/changelog ===
cargo (0.38.0-0ubuntu1~19.10.1) eoan; urgency=medium

  * Backport to Eoan.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 25 Oct 2019 22:18:32 +1300

cargo (0.38.0-0ubuntu1) focal; urgency=medium

  * New upstream release.
  * d/patches/0001-Don-t-fail-if-we-can-t-acquire-readonly-lock.patch,
    d/patches/1001_vendor_serde_atomic-compat.patch: remove, applied
    upstream
  * Refresh other patches.
  * Embed libgit2 at the commit bundled by libgit2 0.8.2 (e3adc99), as
    it depends on a newer version than that found in Ubuntu today, with
    some binary test-only files removed.
    - add debian/libgit2
    - update debian/control
    - update debian/copyright
    - update debian/rules
    - update debian/README.source
  * Hack the libgit2-sys build process to link the bundled libgit2
    against the system's libhttp_parser.
    - add debian/patches/use-system-libhttp-parser.patch
    - update debian/patches/series
  * Cherry pick fixes to tests for compatibility with toml 0.5.3.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 25 Oct 2019 21:45:58 +1300

## cargo 0.39.0

=== debian/changelog ===
cargo (0.39.0-0ubuntu1) focal; urgency=medium

  * New upstream release.
  * d/patches/2001_more_portable_rustflags.patch: Delete, applied
    upstream.
  * Refresh other patches.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 29 Oct 2019 21:09:18 +1300

## cargo 0.39.0+really0.38.0

=== debian/changelog ===
cargo (0.39.0+really0.38.0-0ubuntu1) focal; urgency=medium

  * Re-upload Cargo 0.38 as Cargo 0.39 blocks the bootstrap of rustc 1.38.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 12 Nov 2019 14:01:50 +1300

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,7 @@
 
 override_dh_auto_configure:
 	$(CARGO) prepare-debian $(CURDIR)/vendor
+	cp -a debian/libgit2 vendor/libgit2-sys/
 
 override_dh_auto_build-arch:
 	$(CARGO) build
@@ -49,6 +50,8 @@
 
 override_dh_auto_clean:
 	$(CARGO) clean
+# XXX: Avoid a dependency on a libgit version that isn't in Ubuntu 18.04 and older
+	-$(RM) -rf vendor/libgit2-sys/libgit2
 
 override_dh_clean:
 	# Upstream contains a lot of these

## cargo 0.39.0+really0.39.0

=== debian/changelog ===
cargo (0.39.0+really0.39.0-0ubuntu1) focal; urgency=medium

  * Restore Cargo 0.39 now that the rustc update is done.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 13 Nov 2019 22:49:40 +1300

## cargo 0.40.0

=== debian/changelog ===
cargo (0.40.0-3ubuntu1~18.04.1) bionic; urgency=medium

  * Backport to Bionic. (LP: #1856851)
  * Embed libgit2 0.28.3 to avoid a dependency on a version which is newer
    than that found in disco
    - add debian/libgit2
    - add debian/patches/libgit2-0.28-compat.patch
    - add debian/patches/use-system-libhttp-parser.patch
    - update debian/control
    - update debian/copyright
    - update debiab/patches/series
    - update debian/README.source
    - update debian/rules

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 23 Jan 2020 13:10:56 +1300

cargo (0.40.0-3ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Disable fetch tests on non x86/x86-64 architectures, as those hit an
      unreachable!() in test code. Disable the Debian patch that disables
      these tests on every architecture
      - add debian/patches/disable-fetch-tests-on-non-x86.patch
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh
    - Disable the large_conflict_cache test on non-x86
      - add debian/patches/disable-large_conflict_cache-test-on-non-x86.patch
      - update debian/patches/series
    - Disable test tool_paths::custom_runner which fails every now and again
      because of a libstd bug (https://github.com/rust-lang/rust/issues/55242)
      - add debian/patches/disable-tool_paths-custom_runner.patch
      - update debian/patches/series
  * Dropped changes, included in Debian:
    - d/patches/0001-Don-t-fail-if-we-can-t-acquire-readonly-lock.patch,
      d/patches/1001_vendor_serde_atomic-compat.patch: remove, applied
      upstream
    - d/patches/2001_more_portable_rustflags.patch: Delete, applied
      upstream.
  * Dropped changes, included upstream:
    - Cherry pick fixes to tests for compatibility with toml 0.5.3.
  * Drop bundled libgit2, as Ubuntu now has 0.28.3 which meets the minimum
    requirements.
  * Bump the versioned build-dependency on libgit2-dev.
  * debian/patches/disable-fetch-tests-on-non-x86.patch: update.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 10 Jan 2020 11:51:55 -0800

cargo (0.40.0-3) unstable; urgency=medium

  * debian cargo wrapper: drop DEB_CARGO_PACKAGE in favour of the more
    standardised DESTDIR.
  * Experimental riscv64 support.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Jan 2020 13:31:46 +0000

cargo (0.40.0-2) unstable; urgency=medium

  * Restore patch for pkg-config crate to auto-detect Debian cross-compiling.
  * Add patch for backtrace-sys to auto-detect Debian cross-compiling.

 -- Ximin Luo <infinity0@debian.org>  Thu, 05 Dec 2019 22:31:57 +0000

cargo (0.40.0-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * Ship the zsh completion (Closes: #941437)

  [ Ximin Luo ]
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Thu, 28 Nov 2019 10:24:46 +0000

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,6 @@
 
 export CARGO_HOME = $(CURDIR)/debian/cargo_home
 export DEB_CARGO_CRATE=cargo_$(DEB_VERSION_UPSTREAM)
-export DEB_CARGO_PACKAGE=cargo
 export RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/cargo-$(DEB_VERSION_UPSTREAM)
 
 # don't shrink, this can take ages
@@ -46,7 +45,7 @@
 	# no arch-indep tests
 
 override_dh_auto_install:
-	$(CARGO) install
+	DESTDIR=$(CURDIR)/debian/cargo $(CARGO) install
 
 override_dh_auto_clean:
 	$(CARGO) clean

## cargo 0.41.0

=== debian/changelog ===
cargo (0.41.0-0ubuntu1) focal; urgency=medium

  * "Merge" from Salsa merge request updating to 0.41.0
    https://salsa.debian.org/rust-team/cargo/-/merge_requests/3.
    Remaining changes:
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh
  * Dropped change, libstd bug fixed:
    - Disable test tool_paths::custom_runner which fails every now and again
      because of a libstd bug (https://github.com/rust-lang/rust/issues/55242)
      - add debian/patches/disable-tool_paths-custom_runner.patch
      - update debian/patches/series
  * Dropped change, equivalent change now in Debian:
    - Disable fetch tests on non x86/x86-64 architectures, as those hit an
      unreachable!() in test code. Disable the Debian patch that disables these
      tests on every architecture
      - add debian/patches/disable-fetch-tests-on-non-x86.patch
      - update debian/patches/series
  * Dropped change, test no longer run by upstream build:
   - Disable the large_conflict_cache test on non-x86
     - add debian/patches/disable-large_conflict_cache-test-on-non-x86.patch
     - update debian/patches/series
  * Disable filter_platform test on !x86 as it hits an unreachable!
    - add debian/patches/disable-filter_platform-test-on-non-x86.patch
    - update debian/patches/series

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 02 Mar 2020 08:08:51 +0100

cargo (0.40.0-3ubuntu2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 10:56:41 +0000

## cargo 0.42.0

=== debian/changelog ===
cargo (0.42.0-0ubuntu1) focal; urgency=medium

  * New upstream version. (LP: #1864174)
  * d/scripts/debian-cargo-vendor: use python3 not python.
  * d/patches/2002_disable-net-tests.patch: delete, tests no longer run
    as part of build.
  * Refresh other patches.
  * d/patches/0001-Fix-tests-with-url-crate-update.patch: backport test
    fix from upstream.
  * d/patches/0002-Fix-doc_target-test-which-no-longer-works-on-stable-.patch:
    backport another test fix from upstream.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 03 Mar 2020 07:45:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: cargo
 Section: devel
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,6 @@
 
 override_dh_auto_configure:
 	$(CARGO) prepare-debian $(CURDIR)/vendor
-	cp -a debian/libgit2 vendor/libgit2-sys/
 
 override_dh_auto_build-arch:
 	$(CARGO) build
@@ -49,8 +48,6 @@
 
 override_dh_auto_clean:
 	$(CARGO) clean
-# XXX: Avoid a dependency on a libgit version that isn't in Ubuntu 18.04 and older
-	-$(RM) -rf vendor/libgit2-sys/libgit2
 
 override_dh_clean:
 	# Upstream contains a lot of these

## cargo 0.43.1

=== debian/changelog ===
cargo (0.43.1-3~deb10u1) buster; urgency=medium

  * Non-maintainer upload.
  * Backport to buster.
  * Vendor libgit2, the system one is too old.
  * Revert changes to the cargo wrapper: use debian/DEB_CARGO_PACKAGE
    rather than DESTDIR as the latter is not automatically set by
    buster's debhelper.
  * Bump build-dependency on rustc to 1.41.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Tue, 15 Sep 2020 13:50:29 +0200

cargo (0.43.1-3) unstable; urgency=medium

  * Reupload, actually include the fix described in the previous entry.

 -- Ximin Luo <infinity0@debian.org>  Mon, 20 Apr 2020 14:30:01 +0100

cargo (0.43.1-2) unstable; urgency=medium

  * cargo-debian-wrapper: don't install /usr/.crates2.json. (Closes: #958301)

 -- Ximin Luo <infinity0@debian.org>  Mon, 20 Apr 2020 13:30:57 +0100

cargo (0.43.1-1) unstable; urgency=medium

  [ Fabian Grünbichler ]
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 18 Apr 2020 19:54:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,24 @@
 Source: cargo
 Section: devel
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>,
  Vasudev Kamath <vasudev@copyninja.info>
 Priority: optional
 # :native annotations are to support cross-compiling, see README.Debian of rustc
-Build-Depends: debhelper (>= 9.20141010),
+Build-Depends: debhelper (>= 12~),
                dpkg-dev (>= 1.17.14),
                cargo:native    (>= 0.17.0),
-               rustc:native    (>= 1.16),
-               libstd-rust-dev (>= 1.16),
+               rustc:native    (>= 1.41),
+               libstd-rust-dev (>= 1.41),
                pkg-config,
                cmake,
                bash-completion,
                python3:native,
                libcurl4-gnutls-dev | libcurl4-openssl-dev,
                libssh2-1-dev,
-               libgit2-dev (>= 0.27),
+#               libgit2-dev (>= 0.27),
                libhttp-parser-dev,
                libssl-dev,
                zlib1g-dev,

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 
 export CARGO_HOME = $(CURDIR)/debian/cargo_home
 export DEB_CARGO_CRATE=cargo_$(DEB_VERSION_UPSTREAM)
+export DEB_CARGO_PACKAGE=cargo
 export RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/cargo-$(DEB_VERSION_UPSTREAM)
 
 # don't shrink, this can take ages
@@ -31,6 +32,9 @@
 override_dh_auto_configure:
 	$(CARGO) prepare-debian $(CURDIR)/vendor
 
+	cp -a debian/libgit2-0.28.3+dfsg.1 vendor/libgit2-sys/libgit2
+
+
 override_dh_auto_build-arch:
 	$(CARGO) build
 
@@ -44,11 +48,13 @@
 	# no arch-indep tests
 
 override_dh_auto_install:
-	DESTDIR=$(CURDIR)/debian/cargo $(CARGO) install
+	$(CARGO) install
 
 override_dh_auto_clean:
 	$(CARGO) clean
 
+	-$(RM) -rf vendor/libgit2-sys/libgit2
+
 override_dh_clean:
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig

## cargo 0.44.1

=== debian/changelog ===
cargo (0.44.1-0ubuntu1~18.04.1) bionic; urgency=medium

  * Backport to Bionic. (LP: #1876942)
  * Relax debhelper requirement.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 25 Jun 2020 07:53:54 +1200

cargo (0.44.1-0ubuntu1) groovy; urgency=medium

  * New upstream version. (LP: #1876942)
  * Update scripts/debian-cargo-vendor to invoke python3 and cope with V2
    format Cargo.lock files.
  * Refresh patches.
  * Embed libgit2 1.0.0 which is not yet in Debian or Ubuntu.
    - add debian/libgit2
    - add debian/patches/use-system-libhttp-parser.patch
    - update debian/control
    - update debian/copyright
    - update debiab/patches/series
    - update debian/README.source
    - update debian/rules

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 24 Jun 2020 12:40:56 +1200

cargo (0.43.1-3ubuntu1) groovy; urgency=medium

  * Merge from Debian unstable (LP: #1876942): Remaining changes:
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 May 2020 21:14:18 +1200

cargo (0.42.0-0ubuntu2) groovy; urgency=medium

  * Cherry-pick commit from Debian to remove /usr/.crates2.json (LP: #1868517)

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 29 Apr 2020 13:28:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,26 @@
 Source: cargo
 Section: devel
-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>,
  Vasudev Kamath <vasudev@copyninja.info>
 Priority: optional
 # :native annotations are to support cross-compiling, see README.Debian of rustc
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper (>= 11~),
                dpkg-dev (>= 1.17.14),
                cargo:native    (>= 0.17.0),
-               rustc:native    (>= 1.41),
-               libstd-rust-dev (>= 1.41),
+               rustc:native    (>= 1.16),
+               libstd-rust-dev (>= 1.16),
                pkg-config,
                cmake,
                bash-completion,
                python3:native,
                libcurl4-gnutls-dev | libcurl4-openssl-dev,
                libssh2-1-dev,
-#               libgit2-dev (>= 0.27),
                libhttp-parser-dev,
+               libpcre3-dev,
                libssl-dev,
                zlib1g-dev,
                git <!nocheck>

## cargo 0.47.0

=== debian/changelog ===
cargo (0.47.0-3) unstable; urgency=medium

  * Disable close_output test for now, it is flaky. This is a test problem not
    a cargo problem and will be re-enabled in 0.49.0.

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Dec 2020 01:43:58 +0000

cargo (0.47.0-2) unstable; urgency=medium

  * Backport a patch to fix a test on i386.
  * Add +xgot to work around mips64el limitations.

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Dec 2020 00:29:08 +0000

cargo (0.47.0-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #976434)

 -- Ximin Luo <infinity0@debian.org>  Sun, 06 Dec 2020 12:39:49 +0000

cargo (0.47.0-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 02 Oct 2020 02:04:10 +0100

cargo (0.43.1-4) unstable; urgency=medium

  * Team upload.
  * Fix build by applying two upstream patches. (Closes: #975857)

 -- Jan Niehusmann <jan@debian.org>  Sat, 28 Nov 2020 11:07:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: cargo
 Section: devel
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>,
  Vasudev Kamath <vasudev@copyninja.info>
 Priority: optional
 # :native annotations are to support cross-compiling, see README.Debian of rustc
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper (>= 12~),
                dpkg-dev (>= 1.17.14),
                cargo:native    (>= 0.17.0),
                rustc:native    (>= 1.16),
@@ -19,8 +18,8 @@
                python3:native,
                libcurl4-gnutls-dev | libcurl4-openssl-dev,
                libssh2-1-dev,
+               libgit2-dev (>= 1),
                libhttp-parser-dev,
-               libpcre3-dev,
                libssl-dev,
                zlib1g-dev,
                git <!nocheck>

=== debian/rules ===
--- 
+++ 
@@ -12,8 +12,12 @@
 
 export CARGO_HOME = $(CURDIR)/debian/cargo_home
 export DEB_CARGO_CRATE=cargo_$(DEB_VERSION_UPSTREAM)
-export DEB_CARGO_PACKAGE=cargo
 export RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/cargo-$(DEB_VERSION_UPSTREAM)
+
+# https://github.com/rust-lang/rust/issues/52108
+ifneq (,$(filter $(DEB_HOST_ARCH), mips64el))
+  RUSTFLAGS += -Ctarget-feature=+xgot
+endif
 
 # don't shrink, this can take ages
 # see https://github.com/rust-lang/cargo/issues/6490 for details
@@ -32,9 +36,6 @@
 override_dh_auto_configure:
 	$(CARGO) prepare-debian $(CURDIR)/vendor
 
-	cp -a debian/libgit2-0.28.3+dfsg.1 vendor/libgit2-sys/libgit2
-
-
 override_dh_auto_build-arch:
 	$(CARGO) build
 
@@ -48,13 +49,12 @@
 	# no arch-indep tests
 
 override_dh_auto_install:
-	$(CARGO) install
+	DESTDIR=$(CURDIR)/debian/cargo $(CARGO) install
 
 override_dh_auto_clean:
 	$(CARGO) clean
 
-	-$(RM) -rf vendor/libgit2-sys/libgit2
-
 override_dh_clean:
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig
+	rm -f Cargo.lock

## cargo 0.51.0

=== debian/changelog ===
cargo (0.51.0-0ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh
  * New upstream release. (LP: #1915722)
  * Dropped changes:
    - Embed libgit2 1.0.0 which is not yet in Debian or Ubuntu. (Hirsute
      has a new enough libgit2)
    - d/patches/0001-relax-deprecated-diagnostic-message-check.patch,
      d/patches/u-8713.patch: included in upstream release.
  * d/patches/skip-filter_platform-non-amd64.patch: skip a test that fails on
    non amd64 platforms, see https://github.com/rust-lang/cargo/issues/9238.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 08 Mar 2021 09:10:26 +1300

cargo (0.47.0-1~exp1ubuntu1) hirsute; urgency=medium

  * Merge from Debian experimental (LP: #1901571): Remaining changes:
    - Don't use the bootstrap.py script for bootstrapping as it no longer
      works.
      - remove debian/bootstrap.py
      - update debian/make_orig_multi.sh
    - Embed libgit2 1.0.0 which is not yet in Debian or Ubuntu.
      - add debian/libgit2
      - add debian/patches/use-system-libhttp-parser.patch
      - update debian/control
      - update debian/copyright
      - update debiab/patches/series
      - update debian/README.source
      - update debian/rules
  * d/patches/0001-relax-deprecated-diagnostic-message-check.patch:
    backport fix for tests that fail with rustc 1.47 from upstream.
  * d/patches/skip-filters_target-i386.patch: skip a test that fails on
    i386 for silly reasons.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 09 Dec 2020 10:58:12 +1300

## cargo 0.52.0

=== debian/changelog ===
cargo (0.52.0-0ubuntu1~21.04.1) hirsute; urgency=medium

  * Backport to Hirsute. (LP: #1932145)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 23 Jul 2021 10:59:21 +1200

cargo (0.52.0-0ubuntu1) UNRELEASED; urgency=medium

  * New upstream version.
  * Backport patch from upstream to fix failure with new version of 'tar'
    crate.
  * Add another patch from upstream

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 06 Jul 2021 11:18:18 +1200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: cargo
 Section: devel
-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>,

## cargo 0.53.0

=== debian/changelog ===
cargo (0.53.0-0ubuntu2) jammy; urgency=medium

  * Disable lto::test_profile test on i386.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 26 Oct 2021 11:17:40 +1300

cargo (0.53.0-0ubuntu1) jammy; urgency=medium

  * Do not exclude libgit2 source from libgit2-sys crate.
  * New upstream version.
  * Update patches.
  * Set -march appropriately on armhf.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 22 Oct 2021 16:19:48 +1300

cargo (0.52.0-0ubuntu1) impish; urgency=medium

  * New upstream version.
  * Backport patch from upstream to fix failure with new version of 'tar'
    crate.
  * Add another patch from upstream

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 12 Jul 2021 22:31:53 +1200

=== debian/watch ===
version=3
https://github.com/rust-lang/cargo/releases /rust-lang/cargo/archive.*/(\d+\.\d+\.\d+)\.tar\.gz

## cargo 0.54.0

=== debian/changelog ===
cargo (0.54.0-0ubuntu1~18.04.1) bionic; urgency=medium

  [ Michael Hudson-Doyle ]
  * Backport to Bionic. (LP: #1943842)
  * Relax debhelper requirement.
  * Drop change to -march on armhf.
  * Disable the lto::doctest on i386 too.

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Fri, 29 Oct 2021 13:07:06 +0200

cargo (0.54.0-0ubuntu1) UNRELEASED; urgency=medium

  * Update debian/watch file to account for GitHub changes.
  * New upstream version.
  * Update patches.
  * Cherry pick 2112-handle-4-siphasher-algorithms.patch from Debian.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 27 Oct 2021 10:18:02 +1300

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  Vasudev Kamath <vasudev@copyninja.info>
 Priority: optional
 # :native annotations are to support cross-compiling, see README.Debian of rustc
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper (>= 11~),
                dpkg-dev (>= 1.17.14),
                cargo:native    (>= 0.17.0),
                rustc:native    (>= 1.16),
@@ -19,7 +19,6 @@
                python3:native,
                libcurl4-gnutls-dev | libcurl4-openssl-dev,
                libssh2-1-dev,
-               libgit2-dev (>= 1),
                libhttp-parser-dev,
                libssl-dev,
                zlib1g-dev,

## cargo 0.57.0

=== debian/changelog ===
cargo (0.57.0-7) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Peter Michael Green <plugwash@debian.org>  Mon, 02 May 2022 20:57:46 +0000

cargo (0.57.0-6) experimental; urgency=medium

  * Team upload.
  * Fix debian cargo wrapper to stop looking for subcommands once it finds one
    so that it is possible to test features whose name matches a subcommand.
  * Limit autopkgtest to architectures where it does not run out of disk space.
  * Remove patches for libgit2 1.1.x and adjust dependency for 0.3.x
    (Closes: 1009015)
  * Remove build-dependency on cmake (Closes: 981256)

 -- Peter Michael Green <plugwash@debian.org>  Sun, 10 Apr 2022 00:10:04 +0000

cargo (0.57.0-5) unstable; urgency=medium

  [ Simon Chopin ]
  * Disable cross-build tests in autopkgtests
  * d/p/0001-Change-test-to-not-trigger-emoji-error.patch:
    Cherry-picked from upstream to fix testsuite against rustc 1.57
  * d/p/0002-Remove-eacces-test.patch: Cherry-picked from upstream as
    cargo doesn't seem to trigger the error with recent Rust

 -- Ximin Luo <infinity0@debian.org>  Wed, 09 Mar 2022 13:52:14 +0000

cargo (0.57.0-4) unstable; urgency=medium

  [ Simon Chopin ]
  * Add an autopkgtest for cargo to build itself

  [ Ximin Luo ]
  * Fix FTBFS on x32.

 -- Ximin Luo <infinity0@debian.org>  Mon, 07 Mar 2022 20:35:00 +0000

cargo (0.57.0-3) unstable; urgency=medium

  * Actually fix failing tests.
  * Fix armhf build by backporting a rust-cc patch.

 -- Ximin Luo <infinity0@debian.org>  Sun, 24 Oct 2021 14:11:00 +0100

cargo (0.57.0-2) unstable; urgency=medium

  * Fix failing tests.

 -- Ximin Luo <infinity0@debian.org>  Sun, 24 Oct 2021 13:13:07 +0100

cargo (0.57.0-1) unstable; urgency=medium

  * New upstream release for rustc 1.56.0, 2021 Edition.

 -- Ximin Luo <infinity0@debian.org>  Sun, 24 Oct 2021 01:59:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,29 @@
 Source: cargo
 Section: devel
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Luca Bruno <lucab@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>,
  Vasudev Kamath <vasudev@copyninja.info>
 Priority: optional
 # :native annotations are to support cross-compiling, see README.Debian of rustc
-Build-Depends: debhelper (>= 11~),
-               dpkg-dev (>= 1.17.14),
-               cargo:native    (>= 0.17.0),
-               rustc:native    (>= 1.16),
-               libstd-rust-dev (>= 1.16),
-               pkg-config,
-               cmake,
-               bash-completion,
-               python3:native,
-               libcurl4-gnutls-dev | libcurl4-openssl-dev,
-               libssh2-1-dev,
-               libhttp-parser-dev,
-               libssl-dev,
-               zlib1g-dev,
-               git <!nocheck>
+Build-Depends:
+ debhelper (>= 12~),
+ dpkg-dev (>= 1.17.14),
+ cargo:native    (>= 0.17.0),
+ rustc:native    (>= 1.16),
+ libstd-rust-dev (>= 1.16),
+ pkg-config,
+ bash-completion,
+ python3:native,
+ libcurl4-gnutls-dev | libcurl4-openssl-dev,
+ libssh2-1-dev,
+ libgit2-dev (>= 1.3.0),
+ libgit2-dev (<< 1.4~~),
+ libhttp-parser-dev,
+ libssl-dev,
+ zlib1g-dev,
+ git <!nocheck>
 Homepage: https://crates.io/
 Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/rust-team/cargo.git

## cargo 0.57.0+ubuntu

=== debian/changelog ===
cargo (0.57.0+ubuntu-0ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable (LP: #1952104).
  * Drop all Ubuntu delta, but repack vendor tarball from Debian to contain a
    pristine copy of the libgit2-sys crate, including the bundled libgit2
    source.
  * d/patches/2001-Revert-add-bindings-for-git_branch_name_is_valid-715.patch,
    d/patches/2002-Revert-Bump-libgit2-submodule-to-1.2.0-744.patch: Remove.
  * d/control: Drop libgit2-dev and libhttp-parser-dev from Build-Depends.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 16 Dec 2021 10:39:46 +1300

## cargo 0.58.0

=== libgit2-sys/libgit2/src/CMakeLists.txt ===
add_library(git2internal OBJECT)
set_target_properties(git2internal PROPERTIES C_STANDARD 90)

IF(DEBUG_POOL)
	SET(GIT_DEBUG_POOL 1)
ENDIF()
ADD_FEATURE_INFO(debugpool GIT_DEBUG_POOL "debug pool allocator")

IF(DEBUG_STRICT_ALLOC)
	SET(GIT_DEBUG_STRICT_ALLOC 1)
ENDIF()
ADD_FEATURE_INFO(debugalloc GIT_DEBUG_STRICT_ALLOC "debug strict allocators")

IF(DEBUG_STRICT_OPEN)
	SET(GIT_DEBUG_STRICT_OPEN 1)
ENDIF()
ADD_FEATURE_INFO(debugopen GIT_DEBUG_STRICT_OPEN "path validation in open")

INCLUDE(PkgBuildConfig)
INCLUDE(SanitizeBool)

# This variable will contain the libraries we need to put into
# libgit2.pc's Requires.private. That is, what we're linking to or
# what someone who's statically linking us needs to link to.
SET(LIBGIT2_PC_REQUIRES "")
# This will be set later if we use the system's http-parser library or
# use iconv (OSX) and will be written to the Libs.private field in the
# pc file.
SET(LIBGIT2_PC_LIBS "")

SET(LIBGIT2_INCLUDES
	"${CMAKE_CURRENT_BINARY_DIR}"
	"${libgit2_SOURCE_DIR}/src"
	"${libgit2_SOURCE_DIR}/include")
SET(LIBGIT2_SYSTEM_INCLUDES "")
SET(LIBGIT2_LIBS "")

enable_warnings(missing-declarations)

# Enable tracing
IF(ENABLE_TRACE)
	SET(GIT_TRACE 1)
ENDIF()
ADD_FEATURE_INFO(tracing GIT_TRACE "tracing support")

IF (HAVE_FUTIMENS)
	SET(GIT_USE_FUTIMENS 1)
ENDIF ()
ADD_FEATURE_INFO(futimens GIT_USE_FUTIMENS "futimens support")

CHECK_PROTOTYPE_DEFINITION(qsort_r
	"void qsort_r(void *base, size_t nmemb, size_t size, void *thunk, int (*compar)(void *, const void *, const void *))"
	"" "stdlib.h" HAVE_QSORT_R_BSD)
IF (HAVE_QSORT_R_BSD)
	target_compile_definitions(git2internal PRIVATE HAVE_QSORT_R_BSD)
ENDIF()

CHECK_PROTOTYPE_DEFINITION(qsort_r
	"void qsort_r(void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *, void *), void *arg)"
	"" "stdlib.h" HAVE_QSORT_R_GNU)
IF (HAVE_QSORT_R_GNU)
	target_compile_definitions(git2internal PRIVATE HAVE_QSORT_R_GNU)
ENDIF()

CHECK_FUNCTION_EXISTS(qsort_s HAVE_QSORT_S)
IF (HAVE_QSORT_S)
	target_compile_definitions(git2internal PRIVATE HAVE_QSORT_S)
ENDIF ()

# Find required dependencies

IF(WIN32)
	LIST(APPEND LIBGIT2_LIBS ws2_32)
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
	LIST(APPEND LIBGIT2_LIBS socket nsl)
	LIST(APPEND LIBGIT2_PC_LIBS "-lsocket" "-lnsl")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Haiku")
	LIST(APPEND LIBGIT2_LIBS network)
	LIST(APPEND LIBGIT2_PC_LIBS "-lnetwork")
ENDIF()

CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" NEED_LIBRT)
IF(NEED_LIBRT)
	LIST(APPEND LIBGIT2_LIBS rt)
	LIST(APPEND LIBGIT2_PC_LIBS "-lrt")
ENDIF()

IF(THREADSAFE)
	LIST(APPEND LIBGIT2_LIBS ${CMAKE_THREAD_LIBS_INIT})
	LIST(APPEND LIBGIT2_PC_LIBS ${CMAKE_THREAD_LIBS_INIT})
ENDIF()
ADD_FEATURE_INFO(threadsafe THREADSAFE "threadsafe support")


if(WIN32 AND EMBED_SSH_PATH)
	file(GLOB SRC_SSH "${EMBED_SSH_PATH}/src/*.c")
	list(SORT SRC_SSH)
	target_sources(git2internal PRIVATE ${SRC_SSH})

	list(APPEND LIBGIT2_SYSTEM_INCLUDES "${EMBED_SSH_PATH}/include")
	file(WRITE "${EMBED_SSH_PATH}/src/libssh2_config.h" "#define HAVE_WINCNG\n#define LIBSSH2_WINCNG\n#include \"../win32/libssh2_config.h\"")
	set(GIT_SSH 1)
endif()

IF (WIN32 AND WINHTTP)
	SET(GIT_WINHTTP 1)

	# Since MinGW does not come with headers or an import library for winhttp,
	# we have to include a private header and generate our own import library
	IF (MINGW)
		ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/winhttp" "${libgit2_BINARY_DIR}/deps/winhttp")
		LIST(APPEND LIBGIT2_LIBS winhttp)
		LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/winhttp")
	ELSE()
		LIST(APPEND LIBGIT2_LIBS "winhttp")
		LIST(APPEND LIBGIT2_PC_LIBS "-lwinhttp")
	ENDIF ()

	LIST(APPEND LIBGIT2_LIBS "rpcrt4" "crypt32" "ole32")
	LIST(APPEND LIBGIT2_PC_LIBS "-lrpcrt4" "-lcrypt32" "-lole32")
ENDIF()

include(SelectHTTPSBackend)
include(SelectHashes)
target_sources(git2internal PRIVATE ${SRC_SHA1})

# Specify regular expression implementation
FIND_PACKAGE(PCRE)

IF(REGEX_BACKEND STREQUAL "")
	CHECK_SYMBOL_EXISTS(regcomp_l "regex.h;xlocale.h" HAVE_REGCOMP_L)

	IF(HAVE_REGCOMP_L)
		SET(REGEX_BACKEND "regcomp_l")
	ELSEIF(PCRE_FOUND)
		SET(REGEX_BACKEND "pcre")
	ELSE()
		SET(REGEX_BACKEND "builtin")
	ENDIF()
ENDIF()

IF(REGEX_BACKEND STREQUAL "regcomp_l")
	ADD_FEATURE_INFO(regex ON "using system regcomp_l")
	SET(GIT_REGEX_REGCOMP_L 1)
ELSEIF(REGEX_BACKEND STREQUAL "pcre2")
	FIND_PACKAGE(PCRE2)

	IF(NOT PCRE2_FOUND)
		MESSAGE(FATAL_ERROR "PCRE2 support was requested but not found")
	ENDIF()

	ADD_FEATURE_INFO(regex ON "using system PCRE2")
	SET(GIT_REGEX_PCRE2 1)

	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${PCRE2_INCLUDE_DIRS})
	LIST(APPEND LIBGIT2_LIBS ${PCRE2_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_REQUIRES "libpcre2-8")
ELSEIF(REGEX_BACKEND STREQUAL "pcre")
	ADD_FEATURE_INFO(regex ON "using system PCRE")
	SET(GIT_REGEX_PCRE 1)

	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${PCRE_INCLUDE_DIRS})
	LIST(APPEND LIBGIT2_LIBS ${PCRE_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_REQUIRES "libpcre")
ELSEIF(REGEX_BACKEND STREQUAL "regcomp")
	ADD_FEATURE_INFO(regex ON "using system regcomp")
	SET(GIT_REGEX_REGCOMP 1)
ELSEIF(REGEX_BACKEND STREQUAL "builtin")
	ADD_FEATURE_INFO(regex ON "using bundled PCRE")
	SET(GIT_REGEX_BUILTIN 1)

	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/pcre" "${libgit2_BINARY_DIR}/deps/pcre")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/pcre")
	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:pcre>)
ELSE()
	MESSAGE(FATAL_ERROR "The REGEX_BACKEND option provided is not supported")
ENDIF()

# Optional external dependency: http-parser
IF(USE_HTTP_PARSER STREQUAL "system")
	FIND_PACKAGE(HTTP_Parser)

	IF (HTTP_PARSER_FOUND AND HTTP_PARSER_VERSION_MAJOR EQUAL 2)
		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${HTTP_PARSER_INCLUDE_DIRS})
		LIST(APPEND LIBGIT2_LIBS ${HTTP_PARSER_LIBRARIES})
		LIST(APPEND LIBGIT2_PC_LIBS "-lhttp_parser")
		ADD_FEATURE_INFO(http-parser ON "http-parser support (system)")
	ELSE()
		MESSAGE(FATAL_ERROR "http-parser support was requested but not found")
	ENDIF()
ELSE()
	MESSAGE(STATUS "http-parser version 2 was not found or disabled; using bundled 3rd-party sources.")
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/http-parser" "${libgit2_BINARY_DIR}/deps/http-parser")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/http-parser")
	LIST(APPEND LIBGIT2_OBJECTS "$<TARGET_OBJECTS:http-parser>")
	ADD_FEATURE_INFO(http-parser ON "http-parser support (bundled)")
ENDIF()

# Optional external dependency: zlib
SanitizeBool(USE_BUNDLED_ZLIB)
IF(USE_BUNDLED_ZLIB STREQUAL ON)
	SET(USE_BUNDLED_ZLIB "Bundled")
ENDIF()

IF(USE_BUNDLED_ZLIB STREQUAL "OFF")
	FIND_PACKAGE(ZLIB)
	IF(ZLIB_FOUND)
		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${ZLIB_INCLUDE_DIRS})
		LIST(APPEND LIBGIT2_LIBS ${ZLIB_LIBRARIES})
		IF(APPLE OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
			LIST(APPEND LIBGIT2_PC_LIBS "-lz")
		ELSE()
			LIST(APPEND LIBGIT2_PC_REQUIRES "zlib")
		ENDIF()
		ADD_FEATURE_INFO(zlib ON "using system zlib")
	ELSE()
		MESSAGE(STATUS "zlib was not found; using bundled 3rd-party sources." )
	ENDIF()
ENDIF()
IF(USE_BUNDLED_ZLIB STREQUAL "Chromium")
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/chromium-zlib" "${libgit2_BINARY_DIR}/deps/chromium-zlib")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/chromium-zlib")
	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:chromium_zlib>)
	ADD_FEATURE_INFO(zlib ON "using (Chromium) bundled zlib")
ELSEIF(USE_BUNDLED_ZLIB OR NOT ZLIB_FOUND)
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/zlib" "${libgit2_BINARY_DIR}/deps/zlib")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/zlib")
	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:zlib>)
	ADD_FEATURE_INFO(zlib ON "using bundled zlib")
ENDIF()

# Optional external dependency: libssh2
IF (USE_SSH)
	FIND_PKGLIBRARIES(LIBSSH2 libssh2)
	IF (NOT LIBSSH2_FOUND)
		FIND_PACKAGE(LibSSH2)
		SET(LIBSSH2_INCLUDE_DIRS ${LIBSSH2_INCLUDE_DIR})
		GET_FILENAME_COMPONENT(LIBSSH2_LIBRARY_DIRS "${LIBSSH2_LIBRARY}" DIRECTORY)
		SET(LIBSSH2_LIBRARIES ${LIBSSH2_LIBRARY})
		SET(LIBSSH2_LDFLAGS "-lssh2")
	ENDIF()
ENDIF()
IF (LIBSSH2_FOUND)
	SET(GIT_SSH 1)
	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${LIBSSH2_INCLUDE_DIRS})
	LIST(APPEND LIBGIT2_LIBS ${LIBSSH2_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_LIBS ${LIBSSH2_LDFLAGS})

	CHECK_LIBRARY_EXISTS("${LIBSSH2_LIBRARIES}" libssh2_userauth_publickey_frommemory "${LIBSSH2_LIBRARY_DIRS}" HAVE_LIBSSH2_MEMORY_CREDENTIALS)
	IF (HAVE_LIBSSH2_MEMORY_CREDENTIALS)
		SET(GIT_SSH_MEMORY_CREDENTIALS 1)
	ENDIF()
ELSE()
	MESSAGE(STATUS "LIBSSH2 not found. Set CMAKE_PREFIX_PATH if it is installed outside of the default search path.")
ENDIF()
ADD_FEATURE_INFO(SSH GIT_SSH "SSH transport support")

# Optional external dependency: ntlmclient
IF (USE_NTLMCLIENT)
	SET(GIT_NTLM 1)
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/ntlmclient" "${libgit2_BINARY_DIR}/deps/ntlmclient")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/ntlmclient")
	LIST(APPEND LIBGIT2_OBJECTS "$<TARGET_OBJECTS:ntlmclient>")
ENDIF()
ADD_FEATURE_INFO(ntlmclient GIT_NTLM "NTLM authentication support for Unix")

# Optional external dependency: GSSAPI

INCLUDE(SelectGSSAPI)

# Optional external dependency: iconv
IF (USE_ICONV)
	FIND_PACKAGE(Iconv)
ENDIF()
IF (ICONV_FOUND)
	SET(GIT_USE_ICONV 1)
	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${ICONV_INCLUDE_DIR})
	LIST(APPEND LIBGIT2_LIBS ${ICONV_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_LIBS ${ICONV_LIBRARIES})
ENDIF()
ADD_FEATURE_INFO(iconv GIT_USE_ICONV "iconv encoding conversion support")


IF (THREADSAFE)
	IF (NOT WIN32)
		FIND_PACKAGE(Threads REQUIRED)
	ENDIF()

	SET(GIT_THREADS 1)
ENDIF()

IF (USE_NSEC)
	SET(GIT_USE_NSEC 1)
ENDIF()

IF (HAVE_STRUCT_STAT_ST_MTIM)
	SET(GIT_USE_STAT_MTIM 1)
ELSEIF (HAVE_STRUCT_STAT_ST_MTIMESPEC)
	SET(GIT_USE_STAT_MTIMESPEC 1)
ELSEIF (HAVE_STRUCT_STAT_ST_MTIME_NSEC)
	SET(GIT_USE_STAT_MTIME_NSEC 1)
ENDIF()

target_compile_definitions(git2internal PRIVATE _FILE_OFFSET_BITS=64)

# Collect sourcefiles
file(GLOB SRC_H
	"${libgit2_SOURCE_DIR}/include/git2.h"
	"${libgit2_SOURCE_DIR}/include/git2/*.h"
	"${libgit2_SOURCE_DIR}/include/git2/sys/*.h")
list(SORT SRC_H)
target_sources(git2internal PRIVATE ${SRC_H})

# On Windows use specific platform sources
if(WIN32 AND NOT CYGWIN)
	SET(WIN_RC "win32/git2.rc")

	file(GLOB SRC_OS win32/*.c win32/*.h)
	list(SORT SRC_OS)
	target_sources(git2internal PRIVATE ${SRC_OS})
elseif(AMIGA)
	target_compile_definitions(git2internal PRIVATE NO_ADDRINFO NO_READDIR_R NO_MMAP)
else()
	file(GLOB SRC_OS unix/*.c unix/*.h)
	list(SORT SRC_OS)
	target_sources(git2internal PRIVATE ${SRC_OS})
endif()

IF (USE_LEAK_CHECKER STREQUAL "valgrind")
	target_compile_definitions(git2internal PRIVATE VALGRIND)
ENDIF()

file(GLOB SRC_GIT2 *.c *.h
	allocators/*.c allocators/*.h
	streams/*.c streams/*.h
	transports/*.c transports/*.h
	xdiff/*.c xdiff/*.h)
list(SORT SRC_GIT2)
target_sources(git2internal PRIVATE ${SRC_GIT2})

IF(APPLE)
	# The old Secure Transport API has been deprecated in macOS 10.15.
	SET_SOURCE_FILES_PROPERTIES(streams/stransport.c PROPERTIES COMPILE_FLAGS -Wno-deprecated)
ENDIF()

# the xdiff dependency is not (yet) warning-free, disable warnings as
# errors for the xdiff sources until we've sorted them out
IF(MSVC)
	SET_SOURCE_FILES_PROPERTIES(xdiff/xdiffi.c PROPERTIES COMPILE_FLAGS -WX-)
	SET_SOURCE_FILES_PROPERTIES(xdiff/xutils.c PROPERTIES COMPILE_FLAGS -WX-)
ENDIF()

# Determine architecture of the machine
IF (CMAKE_SIZEOF_VOID_P EQUAL 8)
	SET(GIT_ARCH_64 1)
ELSEIF (CMAKE_SIZEOF_VOID_P EQUAL 4)
	SET(GIT_ARCH_32 1)
ELSEIF (CMAKE_SIZEOF_VOID_P)
	MESSAGE(FATAL_ERROR "Unsupported architecture (pointer size is ${CMAKE_SIZEOF_VOID_P} bytes)")
ELSE()
	MESSAGE(FATAL_ERROR "Unsupported architecture (CMAKE_SIZEOF_VOID_P is unset)")
ENDIF()

CONFIGURE_FILE(features.h.in git2/sys/features.h)

IDE_SPLIT_SOURCES(git2internal)
LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:git2internal>)

TARGET_INCLUDE_DIRECTORIES(git2internal PRIVATE ${LIBGIT2_INCLUDES} PUBLIC ${libgit2_SOURCE_DIR}/include)

=== debian/changelog ===
cargo (0.58.0-0ubuntu1~21.10.1) impish; urgency=medium

  * Backport to Impish. (LP: #1952104)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 25 Jan 2022 19:45:44 +1300

cargo (0.58.0-0ubuntu1) jammy; urgency=medium

  * New upstream version. (LP: #1952104)
  * d/patches/2110-use-mfpu-on-armhf.patch: delete, fixed upstream.
  * d/patches/filetime-pr-75.patch: Backport fix from filetime crate to
    fix ftbfs on s390x.
  * d/patches/libc-pr-2642.patch: Partially backport upstream PR to fix
    another ftbfs on s390x.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 25 Jan 2022 14:06:06 +1300
